#define	CURSES_LIBRARY	1
#include <curses.h>
#undef	typeahead

#ifdef PDCDEBUG
char *rcsid_typeahea = "$Header: c:/curses/portable/RCS/typeahea.c%v 2.0 1992/11/15 03:29:19 MH Rel $";
#endif

#if 0
extern	short	c_pindex;		/* putter index			*/
extern	short	c_gindex;		/* getter index			*/
extern	short	c_ungind;		/* wungetch() push index	*/
extern	chtype	c_ungch[NUNGETCH];	/* array of ungotten chars	*/
extern	WINDOW*	_getch_win_;
#endif

/*man-start*********************************************************************

  typeahead()	- check for type-ahead

  X/Open Description:
 	The curses package does the "line-breakout optimisation" by
 	looking for type-ahead periodically while updating the screen.
 	If input is found, the current update will be postponed until
 	refresh() or doupdate() are called again.  This allows faster
 	response to commands typed in advance.  Normally, the input FILE
 	pointer passed to newterm(), or stdin in the case when initscr()
 	was called, will be used to do this type-ahead checking.  The
 	typeahead() routine specified that the file descriptor fd is to
 	be used to check for type-ahead instead.  If fd is -1, then no
 	type-ahead checking will be done.

  PDCurses Description:
 	Previous version of this function have been incorrect. 
 	Version 2.1 corrected the inconsistancy.

  X/Open Return Value:
 	The typeahead() routine returns the value of the previous file
 	descriptor.

  Portability:
 	PDCurses	int typeahead( int fd );
 	SysV Curses	
 	BSD Curses	
 	X/Open Dec '88	int typeahead( int fd );

**man-end**********************************************************************/

int	typeahead( int fd )
{
 static int saved_fd;
 int old_fd;

#ifdef PDCDEBUG
	if (trace_on) PDC_debug("typeahead() - called\n");
#endif

	old_fd = saved_fd;
	saved_fd = fd;
	if (fd == (-1))
		_cursvar.refrbrk = FALSE;
	else
		_cursvar.refrbrk = TRUE;
	return(old_fd);



#if 0
	if (c_ungind)
		return (TRUE);			/* ungotten char */
	if (c_pindex > c_gindex)
		return (TRUE);			/* buffered char */
#ifdef UNIX
	return(PDC_kbhit());
#else
	return((bool)PDC_check_bios_key());	/* normal mode test */
#endif
#endif
}
